Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_min.cfg	(revision 128)
+++ 	(revision )
@@ -1,12 +1,0 @@
-Dcache_Access
-1	1	+1	# nb_execute_loop        
-1	1	+1	# nb_load_store_unit [0]       [nb_execute_loop]
-1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_dcache_port         
-32	32	+1	# size_address           
-32	32	+1	# size_data              
-0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	1	+1	# priority               
-0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_mono_execute_loop1.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_mono_execute_loop1.cfg	(revision 128)
+++ 	(revision )
@@ -1,24 +1,0 @@
-Dcache_Access
-1	1	+1	# nb_execute_loop        
-4	4	+1	# nb_load_store_unit [0]       [nb_execute_loop]
-1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [0][1]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [0][2]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [0][3]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_dcache_port         
-32	32	+1	# size_address           
-32	32	+1	# size_data              
-0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	0	+1	# table_routing      [0][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	0	+1	# table_routing      [0][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	0	+1	# table_routing      [0][3][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	1	+1	# priority               
-0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_mono_execute_loop2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_mono_execute_loop2.cfg	(revision 128)
+++ 	(revision )
@@ -1,27 +1,0 @@
-Dcache_Access
-1	1	+1	# nb_execute_loop        
-4	4	+1	# nb_load_store_unit [0]       [nb_execute_loop]
-1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
-2	2	+1	# nb_cache_access    [0][1]    [nb_execute_loop][nb_load_store_unit]
-3	3	+1	# nb_cache_access    [0][2]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [0][3]    [nb_execute_loop][nb_load_store_unit]
-4	4	+1	# nb_dcache_port         
-32	32	+1	# size_address           
-32	32	+1	# size_data              
-0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [0][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-2	2	+1	# table_routing      [0][1][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-2	2	+1	# table_routing      [0][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [0][2][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	0	+1	# table_routing      [0][2][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [0][3][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	1	+1	# priority               
-0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_multi_execute_loop1.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_multi_execute_loop1.cfg	(revision 128)
+++ 	(revision )
@@ -1,40 +1,0 @@
-Dcache_Access
-3	3	+1	# nb_execute_loop        
-1	1	+1	# nb_load_store_unit [0]       [nb_execute_loop]
-2	2	+1	# nb_load_store_unit [1]       [nb_execute_loop]
-3	3	+1	# nb_load_store_unit [2]       [nb_execute_loop]
-1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
-2	2	+1	# nb_cache_access    [1][0]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [1][1]    [nb_execute_loop][nb_load_store_unit]
-3	3	+1	# nb_cache_access    [2][0]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [2][1]    [nb_execute_loop][nb_load_store_unit]
-4	4	+1	# nb_cache_access    [2][2]    [nb_execute_loop][nb_load_store_unit]
-4	4	+1	# nb_dcache_port         
-32	32	+1	# size_address           
-32	32	+1	# size_data              
-0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [1][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [1][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-2	2	+1	# table_routing      [1][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [2][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [2][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [2][0][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	0	+1	# table_routing      [2][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [2][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [2][2][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [2][2][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [2][2][3] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	1	+1	# priority               
-0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_multi_execute_loop2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/config_multi_execute_loop2.cfg	(revision 128)
+++ 	(revision )
@@ -1,40 +1,0 @@
-Dcache_Access
-3	3	+1	# nb_execute_loop        
-1	1	+1	# nb_load_store_unit [0]       [nb_execute_loop]
-2	2	+1	# nb_load_store_unit [1]       [nb_execute_loop]
-3	3	+1	# nb_load_store_unit [2]       [nb_execute_loop]
-1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
-2	2	+1	# nb_cache_access    [1][0]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [1][1]    [nb_execute_loop][nb_load_store_unit]
-3	3	+1	# nb_cache_access    [2][0]    [nb_execute_loop][nb_load_store_unit]
-1	1	+1	# nb_cache_access    [2][1]    [nb_execute_loop][nb_load_store_unit]
-4	4	+1	# nb_cache_access    [2][2]    [nb_execute_loop][nb_load_store_unit]
-8	8	+1	# nb_dcache_port         
-32	32	+1	# size_address           
-32	32	+1	# size_data              
-0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_thread_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# size_packet_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
-0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [1][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-2	2	+1	# table_routing      [1][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [1][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-4	4	+1	# table_routing      [2][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-5	5	+1	# table_routing      [2][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-6	6	+1	# table_routing      [2][0][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-7	7	+1	# table_routing      [2][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	0	+1	# table_routing      [2][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-1	1	+1	# table_routing      [2][2][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-2	2	+1	# table_routing      [2][2][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-3	3	+1	# table_routing      [2][2][3] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
-0	1	+1	# priority               
-0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_min.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_min.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_min.gen	(revision 145)
@@ -0,0 +1,12 @@
+Dcache_Access
+1	1	+1	# nb_execute_loop        
+1	1	+1	# nb_load_store_unit [0]       [nb_execute_loop]
+1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_dcache_port         
+32	32	+1	# size_address           
+32	32	+1	# size_data              
+0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	1	+1	# priority               
+0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_mono_execute_loop1.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_mono_execute_loop1.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_mono_execute_loop1.gen	(revision 145)
@@ -0,0 +1,24 @@
+Dcache_Access
+1	1	+1	# nb_execute_loop        
+4	4	+1	# nb_load_store_unit [0]       [nb_execute_loop]
+1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [0][1]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [0][2]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [0][3]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_dcache_port         
+32	32	+1	# size_address           
+32	32	+1	# size_data              
+0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	0	+1	# table_routing      [0][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	0	+1	# table_routing      [0][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	0	+1	# table_routing      [0][3][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	1	+1	# priority               
+0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_mono_execute_loop2.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_mono_execute_loop2.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_mono_execute_loop2.gen	(revision 145)
@@ -0,0 +1,27 @@
+Dcache_Access
+1	1	+1	# nb_execute_loop        
+4	4	+1	# nb_load_store_unit [0]       [nb_execute_loop]
+1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
+2	2	+1	# nb_cache_access    [0][1]    [nb_execute_loop][nb_load_store_unit]
+3	3	+1	# nb_cache_access    [0][2]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [0][3]    [nb_execute_loop][nb_load_store_unit]
+4	4	+1	# nb_dcache_port         
+32	32	+1	# size_address           
+32	32	+1	# size_data              
+0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][3]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [0][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+2	2	+1	# table_routing      [0][1][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+2	2	+1	# table_routing      [0][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [0][2][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	0	+1	# table_routing      [0][2][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [0][3][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	1	+1	# priority               
+0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_multi_execute_loop1.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_multi_execute_loop1.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_multi_execute_loop1.gen	(revision 145)
@@ -0,0 +1,40 @@
+Dcache_Access
+3	3	+1	# nb_execute_loop        
+1	1	+1	# nb_load_store_unit [0]       [nb_execute_loop]
+2	2	+1	# nb_load_store_unit [1]       [nb_execute_loop]
+3	3	+1	# nb_load_store_unit [2]       [nb_execute_loop]
+1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
+2	2	+1	# nb_cache_access    [1][0]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [1][1]    [nb_execute_loop][nb_load_store_unit]
+3	3	+1	# nb_cache_access    [2][0]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [2][1]    [nb_execute_loop][nb_load_store_unit]
+4	4	+1	# nb_cache_access    [2][2]    [nb_execute_loop][nb_load_store_unit]
+4	4	+1	# nb_dcache_port         
+32	32	+1	# size_address           
+32	32	+1	# size_data              
+0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [1][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [1][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+2	2	+1	# table_routing      [1][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [2][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [2][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [2][0][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	0	+1	# table_routing      [2][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [2][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [2][2][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [2][2][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [2][2][3] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	1	+1	# priority               
+0	1	+1	# load_balancing         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_multi_execute_loop2.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_multi_execute_loop2.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/SelfTest/configuration/config_multi_execute_loop2.gen	(revision 145)
@@ -0,0 +1,40 @@
+Dcache_Access
+3	3	+1	# nb_execute_loop        
+1	1	+1	# nb_load_store_unit [0]       [nb_execute_loop]
+2	2	+1	# nb_load_store_unit [1]       [nb_execute_loop]
+3	3	+1	# nb_load_store_unit [2]       [nb_execute_loop]
+1	1	+1	# nb_cache_access    [0][0]    [nb_execute_loop][nb_load_store_unit]
+2	2	+1	# nb_cache_access    [1][0]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [1][1]    [nb_execute_loop][nb_load_store_unit]
+3	3	+1	# nb_cache_access    [2][0]    [nb_execute_loop][nb_load_store_unit]
+1	1	+1	# nb_cache_access    [2][1]    [nb_execute_loop][nb_load_store_unit]
+4	4	+1	# nb_cache_access    [2][2]    [nb_execute_loop][nb_load_store_unit]
+8	8	+1	# nb_dcache_port         
+32	32	+1	# size_address           
+32	32	+1	# size_data              
+0	0	+1	# size_thread_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_thread_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [0][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [1][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [1][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [2][0]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [2][1]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# size_packet_id     [2][2]    [nb_execute_loop][nb_load_store_unit]
+0	0	+1	# table_routing      [0][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [1][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+2	2	+1	# table_routing      [1][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [1][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+4	4	+1	# table_routing      [2][0][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+5	5	+1	# table_routing      [2][0][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+6	6	+1	# table_routing      [2][0][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+7	7	+1	# table_routing      [2][1][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	0	+1	# table_routing      [2][2][0] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+1	1	+1	# table_routing      [2][2][1] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+2	2	+1	# table_routing      [2][2][2] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+3	3	+1	# table_routing      [2][2][3] [nb_execute_loop][nb_load_store_unit][nb_cache_access]
+0	1	+1	# priority               
+0	1	+1	# load_balancing         