Index: anr/section-7.tex
===================================================================
--- anr/section-7.tex	(revision 152)
+++ anr/section-7.tex	(revision 155)
@@ -6,5 +6,5 @@
 \begin{figure}\leavevmode\center
 \input{table_inria_cairn_full.tex}
-\caption{\label{ress-detail-irisa}Man power in $mm$ for the delivrables of \irisa.}
+\caption{\label{ress-detail-irisa}Man power in $mm$ for the deliverables of \irisa.}
 \end{figure}
 \begin{description}
@@ -19,5 +19,5 @@
 
 The table below summarizes the manpower by tasks for both permanent and non-permanent
-personnels. The detail by delivrables is given in figure~\ref{ress-detail-irisa}.
+personnels. The detail by deliverables is given in figure~\ref{ress-detail-irisa}.
 The non-permanent personnels costs represent \mustbecompleted{??\%} of the personnal
 costs. The requested funding for non permanent personnels is 100\% of
@@ -43,5 +43,5 @@
 No specific equipment acquisition. 
 \item [Personnel costs]
-The faculty members involved in the project are a professor at ENS
+The faculty members involved in the project are an emeritus professor at ENS
 Lyon (Paul Feautrier) and a research associate (CR2) at INRIA
 Rh\^one-Alpes (Christophe Alias). The non-permanent personal required
@@ -52,5 +52,5 @@
 techniques and to produce a working implementation.
 
-The table below summarizes the man power by delivrables and tasks for both permanent and
+The table below summarizes the man power by deliverables and tasks for both permanent and
 non-permanent personnels.
 The non-permanent personnels costs represent \mustbecompleted{??\%} of the personnal
@@ -75,5 +75,5 @@
 \begin{figure}\leavevmode\center
 \input{table_tima_full.tex}
-\caption{\label{ress-detail-tima}Man power in $mm$ for the delivrables of \tima.}
+\caption{\label{ress-detail-tima}Man power in $mm$ for the deliverables of \tima.}
 \end{figure}
 \begin{description}
@@ -97,5 +97,5 @@
 
 The table below sumarizes the man power by task for both permanent and non-permanent
-personnels. The detail by delivrables is given in figure~\ref{ress-detail-tima}.
+personnels. The detail by deliverables is given in figure~\ref{ress-detail-tima}.
 The requested funding for personnels represent 50\% of the total personnal costs.
 The requested funding for non permanent personnels is 85\% of the total ANR
@@ -117,5 +117,5 @@
 \begin{figure}\leavevmode\center
 \input{table_ubs_full.tex}
-\caption{\label{ress-detail-ubs}Man power in $mm$ for the delivrables of \ubs.}
+\caption{\label{ress-detail-ubs}Man power in $mm$ for the deliverables of \ubs.}
 \end{figure}
 
@@ -131,5 +131,5 @@
 
 The table below sumarizes the man power by task for both permanent and non-permanent
-personnels. The detail by delivrables is given in figure~\ref {ress-detail-ubs}.
+personnels. The detail by deliverables is given in figure~\ref {ress-detail-ubs}.
 The non-permanent personnels costs represent 50\% of the personnal costs.
 The requested funding for non permanent personnels is about 83\% of the total ANR
@@ -152,5 +152,5 @@
 \begin{figure}\leavevmode\center
 \input{table_upmc_full.tex}
-\caption{\label{ress-detail-upmc}Man power in $mm$ for the delivrables of \upmc.}
+\caption{\label{ress-detail-upmc}Man power in $mm$ for the deliverables of \upmc.}
 \end{figure}
 \begin{description}
@@ -166,5 +166,5 @@
     for senior researchers (post-doc or research engineers).
     The table below sumarizes the man power by task for both permanent  and non-permanent
-    personnels. The detail by delivrables is given in figure~\ref{ress-detail-upmc}.
+    personnels. The detail by deliverables is given in figure~\ref{ress-detail-upmc}.
     The non-permanent personnels costs represent 50\% of the personnal costs.
     The requested funding for non permanent personnels is 79\% of the total ANR
@@ -187,5 +187,5 @@
 \begin{figure}\leavevmode\center
 \input{table_xilinx_full.tex}
-\caption{\label{ress-detail-xilinx}Man power in $mm$ for the delivrables of \xilinx.}
+\caption{\label{ress-detail-xilinx}Man power in $mm$ for the deliverables of \xilinx.}
 \end{figure}
 \begin{description}
@@ -194,5 +194,5 @@
 \item[Personnel costs]
     \xilinx employees involved in the project are permanent Software Engineers.
-    The detail by delivrables is given in figure~\ref{ress-detail-xilinx} and
+    The detail by deliverables is given in figure~\ref{ress-detail-xilinx} and
     a sumary by task in the following table.
     \begin{center}\input{table_xilinx_short.tex}\end{center}
@@ -267,5 +267,5 @@
     A permanent engineer will be assigned on average 1/3 time for
 	all the duration of the project.
-    The table below shows the estimated manpower cost in months for the delivrables.
+    The table below shows the estimated manpower cost in months for the deliverables.
     \begin{center}\input{table_navtel_full.tex}\end{center}
 \item[Subcontracting]